<?php
ob_start();
/*
 *
 *  StatSig for Armagetron Advanced, by Dave Fancella
 *  
 *  @version $Id: statsig.php,v 1.1.1.1 2005/02/19 01:27:59 dave Exp $
 *
 *  This file is part of StatSig.
 *   
 *  StatSig is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  StatSig is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with StatSig; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  StatSig is copyright 2005 by David Fancella
 *
 */

$includeroot = 'statsig/';
 
require_once($includeroot . "aastats.inc.php");

putenv('GDFONTPATH=' . realpath('./statsig'));

function drawtext(&$image, $text, $x1, $y1, $color, $size=0, $font=5, $angle=0) {
    if(is_int($font)) {
        // Means it's the default font
        imagestring($image,$font,$x1,$y1,$text,$color);
    } else {
        // Means it's a string, so use a truetype font
        Imagettftext($image, $size, $angle, $x1,$y1+$size,$color,realpath('./statsig/' . $font . '.ttf'),$text);
    }
}

function ordinalize($num) {
    if (!is_numeric($num))
        return $num;

    if ($num >= 11 and $num <= 19)
        return $num."th";
    elseif ( $num % 10 == 1 )
        return $num."st";
    elseif ( $num % 10 == 2 )
        return $num."nd";
    elseif ( $num % 10 == 3 )
        return $num."rd";
    else
        return $num."th";
}

$Servers = new aastats;

$allServers['hell'] = array('name'=>'Hell','location'=>'http://davefancella.servebeer.com/aa/champions.php','type'=>'aapassthrough');

$thisPlayer = $_GET['player'];
$thisServer = isset($_GET['server'])
              ? $_GET['server'] : $Servers->globalname;
$backgroundPic = isset($_GET['pic'])
               ? $_GET['pic'] : $includeroot . 'armagetroncross1.png';
               //'statback.png';
$sidemargin = isset($_GET['sm'])
               ? $_GET['sm'] : 3;
$textfaceStr = isset($_GET['tf'])
               ? $_GET['tf'] : "255,255,255";
$textshadowStr = isset($_GET['ts'])
               ? $_GET['ts'] : "0,0,0";
$playerFontStr = isset($_GET['pfnt'])
               ? $_GET['pfnt'] : "default";
$captionFontStr = isset($_GET['cfnt'])
               ? $_GET['cfnt'] : "default";
$statFontStr = isset($_GET['sfnt'])
               ? $_GET['sfnt'] : "default";
$serverFontStr = isset($_GET['servfnt'])
               ? $_GET['servfnt'] : "default";
$ord = isset($_GET['ord'])
               ? $_GET['ord'] : "no";
               
list($tfRed,$tfBlue,$tfGreen) = explode(",",$textfaceStr);
if($textshadowStr != 'off') {
    $shadowText = true;
    list($tsRed,$tsBlue,$tsGreen) = explode(",",$textshadowStr);
} else {
    $shadowText = false;
}

if( $ord == "yes" ) {
    $ordRank = true;
} else {
    $ordRank = false;
}

if($thisServer != $Servers->globalname) {
    $dumbTmp = $allServers[$thisServer];
    $serverStr = $dumbTmp['name'];
} else {
    $serverStr = $thisServer;
}

foreach($allServers as $key=>$aServer) {
    $myserver = new aaserver($key,$aServer['location'],$aServer['type']);
    $Servers->AddServer($myserver);
    $Servers->LoadServer($key);
    unset($myserver);
}

$Servers->LoadGlobalServer();

$ladder = $Servers->GetPlayerLadder($thisServer,$thisPlayer);
$matches = $Servers->GetPlayerMatches($thisServer,$thisPlayer);
$rounds = $Servers->GetPlayerRounds($thisServer,$thisPlayer);

// Figure out what kind of picture the background image is and load it

$extension = strtolower(substr(strrchr($backgroundPic, "."), 1));

switch($extension) {
    case 'png':
        header ("Content-type: image/x-png");
        $thePicture = @imagecreatefrompng($backgroundPic);
        break;
    case 'gif':
        header ("Content-type: image/gif");
        $thePicture = @imagecreatefromgif($backgroundPic);
        break;
    case 'jpg':
        header ("Content-type: image/jpeg");
        $thePicture = @imagecreatefromjpg($backgroundPic);    
        break;
    default:
        exit();
}

$discard = ob_end_clean();

// Now handle the fonts

// this is the font that show's the player's name and the server's name
if($playerFontStr == 'default') {
    $playerfont = 5;
    $playersize = 16;
} else {
    $playerfont = $playerFontStr;
    $playersize = 12;
}

// this is the font that shows the captions (Rounds, Matches, etc)
if($captionFontStr == 'default') {
    $captionfont = 2;
    $captionsize = 10;
} else {
    $captionfont = $captionFontStr;
    $captionsize = 8;
}

// This is the font used for the numbers
if($statFontStr == 'default') {
    $scorefont = 2;
    $scoresize = 10;
} else {
    $scorefont = $statFontStr;
    $scoresize = 8;
}

// this is the font used for the server
if($serverFontStr == 'default') {
    if(strlen($thisServer) > 13) {
        $serverfont = 2;
    } else {
        $serverfont = 5;
    }
    $serversize = 16;
} else {
    if(strlen($thisServer) > 13) {
        $serversize = 10;
    } else {
        $serversize = 12;
    }
    
    $serverfont = $serverFontStr;
}

// Do we ordinalize the rankings?

if( $ordRank ) {
    $ladderRank = ordinalize($ladder['rank']);
    $roundRank = ordinalize($rounds['rank']);
    $matchRank = ordinalize($matches['rank']);
} else {
    $ladderRank = $ladder['rank'];
    $roundRank = $rounds['rank'];
    $matchRank = $matches['rank'];
}

$topmargin = 3;
$shadowdistance = 2;

$width = imagesx($thePicture);
$height = imagesy($thePicture);

$midpoint = $width/2;
$centerline = $midpoint-1;
$columnstart = ($width-$centerline)/2;

$lineinterval = 18;
$linegap = 1/4*($width-$sidemargin-$centerline-$sidemargin);

$topline = 18;
$firstline = $topline+$lineinterval;

$firstverticalline = $width-$sidemargin;

$textcolorshadow = imagecolorallocate($thePicture, $tsBlue, $tsGreen, $tsRed);
$textface = imagecolorallocate($thePicture, $tfBlue, $tfGreen, $tfRed);

// Draw all shadows first
if($shadowText) {
    // Player name
    drawtext($thePicture, $thisPlayer, $sidemargin+$shadowdistance, $topline-$playersize+$shadowdistance, $textcolorshadow, $playersize, $playerfont);
    
    // Server name
    drawtext($thePicture, $serverStr, $sidemargin+$shadowdistance, $height-$serversize-$topmargin+$shadowdistance, $textcolorshadow, $serversize, $serverfont);
    
    // The line under the player's name
    imageline($thePicture,$sidemargin+$shadowdistance,$topline+$shadowdistance,$width-$sidemargin+$shadowdistance, $topline+$shadowdistance, $textcolorshadow);
    
    // Horizontal lines in chart
    for($lines = 0; $lines < 3; $lines++) {
        imageline($thePicture,$centerline+$shadowdistance,$firstline+($lines*$lineinterval)+$shadowdistance,$width-$sidemargin+$shadowdistance, $firstline+($lines*$lineinterval)+$shadowdistance, $textcolorshadow);
        $lastknowny = $firstline+($lines*$lineinterval);
    }    
    
    // Vertical lines in chart
    for($lines = 0; $lines < 3; $lines++) {
        imageline($thePicture,$width-$sidemargin+$shadowdistance-$lines*$linegap, $topline+$shadowdistance,$width-$sidemargin+$shadowdistance-$lines*$linegap, $lastknowny+$shadowdistance, $textcolorshadow);
    }
    
    // The ladder
    drawtext($thePicture, "Ladder", $centerline+3+$shadowdistance, $topline+4+$shadowdistance, $textcolorshadow, $captionsize, $captionfont);
    drawtext($thePicture, $ladderRank, $columnstart + $centerline+3+$shadowdistance, $topline+4+$shadowdistance, $textcolorshadow, $scoresize, $captionfont);
    drawtext($thePicture, round($ladder['score'],1), $columnstart + $centerline+3+$shadowdistance+$linegap, $topline+4+$shadowdistance, $textcolorshadow, $scoresize, $captionfont);
    
    // Matches
    drawtext($thePicture, "Matches", $centerline+3+$shadowdistance, $topline+$lineinterval+4+$shadowdistance, $textcolorshadow, $captionsize, $captionfont);
    drawtext($thePicture, $matchRank, $columnstart + $centerline+3+$shadowdistance, $topline+$lineinterval+4+$shadowdistance, $textcolorshadow, $scoresize, $captionfont);
    drawtext($thePicture, round($matches['score'],1), $columnstart + $centerline+3+$linegap+$shadowdistance, $topline+$lineinterval+4+$shadowdistance, $textcolorshadow, $scoresize, $captionfont);
    
    // Rounds
    drawtext($thePicture, "Rounds", $centerline+3+$shadowdistance, $topline+$lineinterval*2+4+$shadowdistance,  $textcolorshadow, $captionsize, $captionfont);
    drawtext($thePicture, $roundRank, $columnstart + $centerline+3+$shadowdistance, $topline+$lineinterval*2+4+$shadowdistance, $textcolorshadow, $scoresize, $captionfont);
    drawtext($thePicture, round($rounds['score'],1), $columnstart + $centerline+3+$linegap+$shadowdistance, $topline+$lineinterval*2+4+$shadowdistance, $textcolorshadow, $scoresize, $captionfont);
} else {
    // we still need a value from the shadows, even if we didn't draw them
    for($lines = 0; $lines < 3; $lines++) {
        $lastknowny = $firstline+($lines*$lineinterval);
    }    
}

// Now draw the white faces

// Player name
drawtext($thePicture, $thisPlayer, $sidemargin, $topline-$playersize, $textface, $playersize, $playerfont);

// Server name
drawtext($thePicture, $serverStr, $sidemargin, $height-$serversize-$topmargin, $textface, $serversize, $serverfont);

// The line under the player's name
imageline($thePicture,$sidemargin,$topline,$width-$sidemargin, $topline, $textface);

for($lines = 0; $lines < 3; $lines++) {
    imageline($thePicture,$centerline,$firstline+($lines*$lineinterval),$width-$sidemargin, $firstline+($lines*$lineinterval), $textface);
}    

// The ladder
drawtext($thePicture, "Ladder", $centerline+3, $topline+4, $textface, $captionsize, $captionfont);
drawtext($thePicture, $ladderRank, $columnstart + $centerline+3, $topline+4, $textface, $scoresize, $captionfont);
drawtext($thePicture, round($ladder['score'],1), $columnstart + $centerline+3+$linegap, $topline+4, $textface, $scoresize, $captionfont);

// Matches
drawtext($thePicture, "Matches", $centerline+3, $topline+$lineinterval+4, $textface, $captionsize, $captionfont);
drawtext($thePicture, $matchRank, $columnstart + $centerline+3, $topline+$lineinterval+4, $textface, $scoresize, $captionfont);
drawtext($thePicture, round($matches['score'],1), $columnstart + $centerline+3+$linegap, $topline+$lineinterval+4, $textface, $scoresize, $captionfont);

// Rounds
drawtext($thePicture, "Rounds", $centerline+3, $topline+$lineinterval*2+4,  $textface, $captionsize, $captionfont);
drawtext($thePicture, $roundRank, $columnstart + $centerline+3, $topline+$lineinterval*2+4, $textface, $scoresize, $captionfont);
drawtext($thePicture, round($rounds['score'],1), $columnstart + $centerline+3+$linegap, $topline+$lineinterval*2+4, $textface, $scoresize, $captionfont);

// Vertical lines in chart
for($lines = 0; $lines < 3; $lines++) {
    imageline($thePicture,$width-$sidemargin-$lines*$linegap, $topline,$width-$sidemargin-$lines*$linegap, $lastknowny, $textface);
}

imagepng($thePicture);

?>